/*
 * drivers/dec/char/ds2100_framebuf.c
 *
 * Copyright (C) 1997 Harald/Frieder???
 *
 * Originally written by ??.
 *
 * The DEC DS2100 & DS3100 Framebuffer code for accessing the built-in
 * graphics.
 *
 * FIXME: This was ripped out of decstation.c, and is untested since then.
 */
#include <asm/dec/prom.h>
#include "dec_font_8x16.c"

/* char pos on the screen - x, y, scan_line */
#define FONT_HEIGHT 16
unsigned long column_stride=0;
unsigned long fb_bit_depth=1;
unsigned long buffer_end=0;
#define MONO_STRIDE 256;
#define COLOR_STRIDE 1024;
#define FRAME_BUFFER_BASE 0xAFC00000
#define MONO_BUFFER_END FRAME_BUFFER_BASE+0x40000
#define COLOR_BUFFER_END FRAME_BUFFER_BASE+0x100000
#define CHAR_POS(x,y,l) (FRAME_BUFFER_BASE + column_stride * FONT_HEIGHT * y + x*fb_bit_depth + column_stride * l)

void dec_cons_putc(char c)
{
	static int xp=0, yp=32;
	char *cp;
	int i;

	switch(c)
	{
	case 0x0d:
		xp=0; break;	
	case 0x0a:
		xp=0;
		yp++;
		if (yp > 53)
		{
			yp=53;
			dec_cons_scroll();
		}
		break;
	default:
#if 0
		for (i=0; i<FONT_HEIGHT; i++)
		{
			cp=CHAR_POS(xp,yp,i);
			*cp=fontdata_8x16[i+FONT_HEIGHT*c];
		}
#endif
		for (i=0; i<FONT_HEIGHT; i++)
		{
			int j;
			char z;
			cp=CHAR_POS(xp,yp,i);
			
			z=fontdata_8x16[i+FONT_HEIGHT*c];
                        if(fb_bit_depth>1)
                        {
			for (j=0; j<fb_bit_depth; j++)
			{
				int xx;
				xx=z>>j & 0x01;
				if ( xx == 0 )
					*cp=0;
				else
					*cp=1;
				cp++;
			}
                        }
                        else
                         *cp=z;
		}

		xp++;
		if (xp > 132)
		{	
			xp=0;
			yp++;
			if (yp > 53)
			{
				yp=53;
				dec_cons_scroll();
			}
		}
		break;
	}
}

void dec_cons_scroll(void)
{
	unsigned long /* char */ *cp, *cp1;

	cp=FRAME_BUFFER_BASE;

#if 0
	cp1=0xAFC00000+256*FONT_HEIGHT;
	while(cp1 < 0xAFC00000+256*864)
#endif 

	cp1=FRAME_BUFFER_BASE+column_stride*FONT_HEIGHT;
	while(cp1 < FRAME_BUFFER_BASE+column_stride*864)
	{
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
		*cp=*cp1;
		cp++;
		cp1++;
	}
#if 0
	cp1 = 0xAFC00000 + 256*(864 - FONT_HEIGHT);
#endif
	cp1 = FRAME_BUFFER_BASE + column_stride*(864 - FONT_HEIGHT);
#if 0
	while(cp1 < 0xAFC00000+256*864)
#endif
	while(cp1 < FRAME_BUFFER_BASE +column_stride*864)
	{
		*cp1=0;
		cp1++;
	}
}

void ds2100_init(void)
{
	short *scr;
	int i,j;
	int x,y;
	char *cp;
	char z;
        unsigned int *sys_csr; /* FIXME That should be in some header!! */
	char str[]="DECstation 2100 COLOR console driver 1.0 starting ...";

        sys_csr=0xBE000000;
        if((*sys_csr & 0x0800) != 0)
          {
            /* got a MONO Frame buffer */
            column_stride = MONO_STRIDE;
            buffer_end    = MONO_BUFFER_END;
            fb_bit_depth   = 1;
          }
          else
          {
            /* got a COLOR Frame buffer */
            column_stride = COLOR_STRIDE;
            buffer_end    = COLOR_BUFFER_END;
            fb_bit_depth   = 8;
          }
	
        /* clear screen */
	
        for (cp=FRAME_BUFFER_BASE; cp<buffer_end; cp++)
		*cp=0;

        prom_printf("%s\n",str);

#if 0
	y=30;
	for (x=0; x<strlen(str); x++)
		for (i=0; i<FONT_HEIGHT; i++)
		{
			cp=CHAR_POS(x,y,i);
			*cp=fontdata_8x16[(i+FONT_HEIGHT*(int)(str[x]))];
		}
#endif 

#ifdef 0	
	y=30;
	for (x=0; x<strlen(str); x++)
		for (i=0; i<FONT_HEIGHT; i++)
		{
			cp=CHAR_POS(x,y,i);
			
			z=fontdata_8x16[(i+FONT_HEIGHT*(int)(str[x]))];
			for (j=0; j<fb_bit_depth; j++)
			{
				int xx;
				xx=z>>j & 0x01;
				if ( xx == 0 )
					*cp=0;
				else
					*cp=1;
				cp++;
			}
		}
#endif
}

void outhex(unsigned short s)
{
	short i;
		
	prom_printf(" $");
	i=s/0x1000;
	outd(i);
	s=s-i*0x1000;
	i=s/0x0100;
	outd(i);
	s=s-i*0x0100;
	i=s/0x0010;
	outd(i);
	s=s-i*0x0010;
	i=s;
	outd(i);
}

void outd(int x)
{
	switch(x)
	{
		case 0:	prom_printf("0");
			break;
		case 1:	prom_printf("1");
			break;
		case 2:	prom_printf("2");
			break;
		case 3:	prom_printf("3");
			break;
		case 4:	prom_printf("4");
			break;
		case 5:	prom_printf("5");
			break;
		case 6:	prom_printf("6");
			break;
		case 7:	prom_printf("7");
			break;
		case 8:	prom_printf("8");
			break;
		case 9:	prom_printf("9");
			break;
		case 10:	prom_printf("a");
			break;
		case 11:	prom_printf("b");
			break;
		case 12:	prom_printf("c");
			break;
		case 13:	prom_printf("d");
			break;
		case 14:	prom_printf("e");
			break;
		case 15:	prom_printf("f");
			break;
	}
}
