/*
 * Hardware info about DEC Personal DECStation systems (otherwise known
 * as maxine (internal DEC codename).
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1995,1996 by Paul M. Antoine, some code and definitions
 * are by curteousy of Chris Fraser.
 *
 * This file is under construction - you were warned!
 */

#ifndef __ASM_MIPS_DEC_KN02CA_H 
#define __ASM_MIPS_DEC_KN02CA_H 

/*
 * The addresses below are virtual address. The mappings are
 * created on startup via wired entries in the tlb.
 */

#define KN02_LOCAL_IO_SPACE     0xe0000000

/*
 * Motherboard regs (kseg1 addresses)
 */
#define MAXINE_SSR_ADDR		KSEG1ADDR(0x1c040100)	/* system support reg */

/*
 * SSR defines
 */
#define MAXINE_SSR_LEDMASK	0x00000001		/* power LED */

#ifndef __LANGUAGE_ASSEMBLY__

extern __inline__ void maxine_set_led(unsigned int bits)
{
	volatile unsigned int *led_register = (unsigned int *) MAXINE_SSR_ADDR;

	*led_register = bits & MAXINE_SSR_LEDMASK;
}

#endif

/*
 * Some port addresses...
 * FIXME: these addresses are incomplete and need tidying up!
 */
#define KN02CA_RTC_BASE	(KSEG1ADDR(0x1c000000 + 0x200000)) /* ASIC + SL8 */

/*
 * Interrupt request levels
 */
#define	KN02CA_PERIODIC_IRQ		2
#define	KN02CA_RTC_IRQ			3
#define	KN02CA_MEMCTRLR_IRQ		4
#define	KN02CA_TC_IRQ			5
#define	KN02CA_HALT_IRQ			6

#endif /* __ASM_MIPS_DEC_KN02CA_H */
